

print 'Recreating Primary Keys...'
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK_vds_configuration' AND TABLE_NAME='vds_configuration')
BEGIN
ALTER TABLE vds_configuration ADD CONSTRAINT PK_vds_configuration PRIMARY KEY(vds_id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK_vds_groups' AND TABLE_NAME='vds_group_configuration')
BEGIN
ALTER TABLE vds_group_configuration ADD CONSTRAINT PK_vds_groups PRIMARY KEY( vds_group_id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vds_history__0CBAE877' AND TABLE_NAME='vds_history')
BEGIN
ALTER TABLE vds_history ADD CONSTRAINT PK__vds_history__0CBAE877 PRIMARY KEY( id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vds_interface_co__15502E78' AND TABLE_NAME='vds_interface_configuration')
BEGIN
ALTER TABLE vds_interface_configuration ADD CONSTRAINT PK__vds_interface_co__15502E78 PRIMARY KEY( id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vds_interface_hi__1920BF5C' AND TABLE_NAME='vds_interface_history')
BEGIN
ALTER TABLE vds_interface_history ADD CONSTRAINT PK__vds_interface_hi__1920BF5C PRIMARY KEY( id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK_vm_configuration' AND TABLE_NAME='vm_configuration')
BEGIN
ALTER TABLE vm_configuration ADD CONSTRAINT PK_vm_configuration PRIMARY KEY( vm_guid)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK_vm_disk_configuration' AND TABLE_NAME='vm_disk_configuration')
BEGIN
ALTER TABLE vm_disk_configuration ADD CONSTRAINT PK_vm_disk_configuration PRIMARY KEY( image_guid)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vm_disk_history__1CF15040' AND TABLE_NAME='vm_disk_history')
BEGIN
ALTER TABLE vm_disk_history ADD CONSTRAINT PK__vm_disk_history__1CF15040 PRIMARY KEY( id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vm_history__014935CB' AND TABLE_NAME='vm_history')
BEGIN
ALTER TABLE vm_history ADD CONSTRAINT PK__vm_history__014935CB PRIMARY KEY( id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vm_interface_con__1367E606' AND TABLE_NAME='vm_interface_configuration')
BEGIN
ALTER TABLE vm_interface_configuration ADD CONSTRAINT PK__vm_interface_con__1367E606 PRIMARY KEY( id)
END
go
IF not EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS WHERE CONSTRAINT_SCHEMA='dbo' AND CONSTRAINT_NAME='PK__vm_interface_his__173876EA' AND TABLE_NAME='vm_interface_history')
BEGIN
ALTER TABLE vm_interface_history ADD CONSTRAINT PK__vm_interface_his__173876EA PRIMARY KEY( id)
END
go
print 'Recreating Forign Keys...'
print 'Recreating Indexes...'
IF INDEXPROPERTY ( OBJECT_ID('vm_history') , 'IDX_vm_history_history_datetime' , 'IndexID' ) IS NULL
BEGIN
CREATE    INDEX [IDX_VM_HISTORY_HISTORY_DATETIME]            ON [VM_HISTORY]            (HISTORY_DATETIME)
END
go
IF INDEXPROPERTY ( OBJECT_ID('vds_history') , 'IDX_vds_history_history_datetime' , 'IndexID' ) IS NULL
BEGIN
CREATE    INDEX [IDX_VDS_HISTORY_HISTORY_DATETIME]           ON [VDS_HISTORY]           (HISTORY_DATETIME)
END
go
IF INDEXPROPERTY ( OBJECT_ID('vm_interface_history') , 'IDX_vm_interface_history_history_datetime' , 'IndexID' ) IS NULL
BEGIN
CREATE    INDEX [IDX_VM_INTERFACE_HISTORY_HISTORY_DATETIME]  ON [VM_INTERFACE_HISTORY]  (HISTORY_DATETIME)
END
go
IF INDEXPROPERTY ( OBJECT_ID('vds_interface_history') , 'IDX_vds_interface_history_history_datetime' , 'IndexID' ) IS NULL
BEGIN
CREATE    INDEX [IDX_VDS_INTERFACE_HISTORY_HISTORY_DATETIME] ON [VDS_INTERFACE_HISTORY] (HISTORY_DATETIME)
END
go
IF INDEXPROPERTY ( OBJECT_ID('vm_disk_history') , 'IDX_vm_disk_history_history_datetime' , 'IndexID' ) IS NULL
BEGIN
CREATE    INDEX [IDX_VM_DISK_HISTORY_HISTORY_DATETIME]       ON [VM_DISK_HISTORY]       (HISTORY_DATETIME)
END
go
