@ECHO OFF

IF (%3)==() GOTO Usage
set CA_STARTDATE=
IF NOT (%4)==() set CA_STARTDATE=-startdate %4

copy cacert.template cacert.conf
echo C = %1% >> cacert.conf
echo O = %2% >> cacert.conf
echo 0.CN = %3% >> cacert.conf

IF NOT (%5)==() echo 1.CN = %5% >> cacert.conf
IF NOT (%6)==() echo 2.CN = %6 >> cacert.conf

openssl genrsa -out private\ca.pem 1024 && openssl req -new -key private\ca.pem -config cacert.conf -out requests\ca.csr && openssl ca -selfsign -out ca.pem -in requests\ca.csr -keyfile private\ca.pem -days 3650 %CA_STARTDATE% -config openssl.conf -extfile cacert.conf -extensions v3_ca -batch
EXIT /B %ERRORLEVEL%

:Usage
ECHO CreateCA.bat - Creates Certificate Authority certificate and keys
ECHO Usage: 
ECHO     CreateCA [Country] [Organization] [Name] [startdate] <Additional CN 1> <Additional CN 2>
ECHO Where:
ECHO     Country      = 2 Letters country code
ECHO     Organization = Organization name string
ECHO     Name         = CA Subject Name
ECHO     startdate    = in YYMMDDHHMMSSZ ASN1 format
Exit /B 1
