SET NOCOUNT ON
 
-- master storage domain
declare @id_0000 uniqueidentifier
declare @id_0001 uniqueidentifier
declare @id_0002 uniqueidentifier
declare @id_0003 uniqueidentifier
declare @id_1234 uniqueidentifier
declare @id_6469 uniqueidentifier
declare @id_bd1a uniqueidentifier
declare @id_ff76 uniqueidentifier
set @id_0000 = '00000000-0000-0000-0000-000000000000'
set @id_0001 = '00000000-0000-0000-0000-000000000001'
set @id_0002 = '00000000-0000-0000-0000-000000000002'
set @id_0003 = '00000000-0000-0000-0000-000000000003'
set @id_1234 = '00000000-0000-0000-1234-200000000002'
set @id_6469 = '64696452-50f4-43ee-b27a-3d1c792b8600'
set @id_bd1a = 'bd1a86f0-6189-4c18-9dd5-adc4aaaa3665'
set @id_ff76 = 'ff768642-17d2-4ae1-9ac8-2d9c7adbe00f'

if (not exists (select id from storage_domain_static where id = @id_0002))
begin
	Print 'insert master storage domain'
	INSERT into storage_domain_static VALUES (@id_0002,@id_0002,'domain1',@id_0001, 0, 1)
end

if (not exists (select id from storage_domain_dynamic where id = @id_0002))
begin
	INSERT into storage_domain_dynamic (id, status) VALUES (@id_0002, 3)
end

-- ISO

if (not exists (select id from storage_domain_static where id = @id_0003))
begin
	Print 'insert ISO storage domain'
	INSERT into storage_domain_static VALUES (@id_0003,@id_0003,'ISO',@id_0001, 2, 1)
end

if (not exists (select id from storage_domain_dynamic where id = @id_0003))
begin
	INSERT into storage_domain_dynamic (id, status) VALUES (@id_0003, 3)
end

-- storage
if (not exists (select storage_id from storage_pool_iso_map where storage_id = @id_0003 and storage_pool_id = @id_0001))
begin
	Print 'insert ISO pool map'
	INSERT into storage_pool_iso_map (storage_id, storage_pool_id) VALUES (@id_0003,@id_0001)
end

if (not exists (select id from storage_server_connections where id = @id_0002))
begin
	Print 'insert storage connections'
	insert into storage_server_connections (id, connection, storage_type) values(@id_0002, 'multipass:/export/images/rnd/grey/domain1', 1)
end

if (not exists (select id from storage_server_connections where id = @id_0003))
begin
	insert into storage_server_connections (id, connection, storage_type) values(@id_0003, 'multipass:/export/images/rnd/grey/iso1', 1)
end

-- make storage pool active
update storage_pool set status = 2

if (not exists (select it_guid from image_templates where it_guid = @id_bd1a))
begin
	PRINT 'Inserting the XP noacpi golden image'
	INSERT INTO [image_templates] ([it_guid],[os],[os_version],[creation_date],[num_of_sectors],[description],[bootable]) VALUES (@id_bd1a,'WinXP','SP2','2008/04/01 00:00:00',167772160,'winxp_32_vlk_noacpi',1)
	INSERT INTO [images] ([image_guid],[it_guid],[creation_date],[num_of_sectors],[description],[internal_drive_mapping],[ParentId],[imageStatus],[lastModified],[storage_id],[image_group_id],[volume_format]) VALUES (@id_bd1a,@id_0000,'2008/04/01 00:00:00',167772160,'WinXP vlk NOACPI Golden Image','C',@id_0000,1,'2008/04/01 00:00:00',@id_0002,'bd1a86f0-6189-4c18-9dd5-adc4aaaa3664',4)
	INSERT INTO [vm_templates] ([vmt_guid],[name],[mem_size_mb],[os],[creation_date],[child_count],[num_of_sockets],[cpu_per_socket],[description],[vds_group_id],[domain],[num_of_monitors],[status]) VALUES (@id_bd1a,'winxp-32-noacpi-golden-vlk',512,'1','2008/04/01 00:00:00',0,1,1,'winxp-32-noacpi-golden-vlk',0,'',1,0)
	INSERT INTO [vm_template_image_map] ([it_guid],[vmt_guid],[internal_drive_mapping]) VALUES (@id_bd1a,@id_bd1a,'C')
end
-- if (not exists (select it_guid from image_templates where it_guid = @id7))
--begin

	--PRINT 'Inserting the Win 2K noacpi golden image'
	--INSERT INTO [image_templates] ([it_guid],[os],[os_version],[creation_date],[num_of_sectors],[description],[bootable]) VALUES (@id7,'Win2K','SP2','2008/04/01 00:00:00',167772160,'win2k_noacpi',1)
	--INSERT INTO [images] ([image_guid],[it_guid],[creation_date],[num_of_sectors],[actual_num_of_sectors],[description],[internal_drive_mapping],[ParentId],[imageStatus],[lastModified],[storage_id],[image_group_id],[volume_format]) VALUES (@id7,@id_0000,'2008/04/01 00:00:00',167772160,167772160,'Win2K NOACPI Golden Image','C',@id_0000,1,'2008/04/01 00:00:00',@id_0002,'ff768642-17d2-4ae1-9ac8-2d9c7adbe00e',4)
	--INSERT INTO [vm_templates] ([vmt_guid],[name],[mem_size_mb],[os],[creation_date],[child_count],[num_of_sockets],[cpu_per_socket],[description],[vds_group_id],[domain],[num_of_monitors],[status]) VALUES (@id7,'win2k-noacpi-golden',512,'2','2008/04/01 00:00:00',0,1,1,'win2k-noacpi-golden',0,'',1,0)
	--INSERT INTO [vm_template_image_map] ([it_guid],[vmt_guid],[internal_drive_mapping]) VALUES (@id7,@id7,'C')
--end

if (not exists (select it_guid from image_templates where it_guid = @id_1234))
begin
	PRINT 'Inserting the Win 2003 noacpi vlk golden image'
	INSERT INTO [image_templates] ([it_guid],[os],[os_version],[creation_date],[num_of_sectors],[description],[bootable]) VALUES (@id_1234,'Win2003','SP2','2008/04/01 00:00:00',167772160,'win2003_noacpi_vlk',1)
	INSERT INTO [images] ([image_guid],[it_guid],[creation_date],[num_of_sectors],[description],[internal_drive_mapping],[ParentId],[imageStatus],[lastModified],[storage_id],[image_group_id],[volume_format]) VALUES (@id_1234,@id_0000,'2008/04/01 00:00:00',167772160,'Win2003 NOACPI vlk Golden Image','C',@id_0000,1,'2008/04/01 00:00:00',@id_0002,'00000000-0000-0000-1234-200000000001',4)
	INSERT INTO [vm_templates] ([vmt_guid],[name],[mem_size_mb],[os],[creation_date],[child_count],[num_of_sockets],[cpu_per_socket],[description],[vds_group_id],[domain],[num_of_monitors],[status]) VALUES (@id_1234,'win2003-noacpi-golden-vlk',512,'3','2008/04/01 00:00:00',0,1,1,'win2003-noacpi-golden-vlk',0,'',1,0)
	INSERT INTO [vm_template_image_map] ([it_guid],[vmt_guid],[internal_drive_mapping]) VALUES (@id_1234,@id_1234,'C')
end

if (not exists (select it_guid from image_templates where it_guid = @id_6469))
begin
	PRINT 'Inserting the Win 2003 noacpi vlk  VDC READY golden image'
	INSERT INTO [image_templates] ([it_guid],[os],[os_version],[creation_date],[num_of_sectors],[description],[bootable]) VALUES (@id_6469,'Win2003','SP2','2008/04/01 00:00:00',167772160,'win2003_noacpi_vlk_VDC',1)
	INSERT INTO [images] ([image_guid],[it_guid],[creation_date],[num_of_sectors],[description],[internal_drive_mapping],[ParentId],[imageStatus],[lastModified],[storage_id],[image_group_id],[volume_format]) VALUES (@id_6469,@id_0000,'2008/04/01 00:00:00',167772160,'Win2003 NOACPI vlk VDC Golden Image','C',@id_0000,1,'2008/04/01 00:00:00',@id_0002,'64696452-50f4-43ee-b27a-3d1c792b85ff',4)
	INSERT INTO [vm_templates] ([vmt_guid],[name],[mem_size_mb],[os],[creation_date],[child_count],[num_of_sockets],[cpu_per_socket],[description],[vds_group_id],[domain],[num_of_monitors],[status]) VALUES (@id_6469,'VDC_win2003-noacpi-golden-vlk',512,'3','2008/04/01 00:00:00',0,1,1,'VDC_win2003-noacpi-golden-vlk',0,'',1,0)
	INSERT INTO [vm_template_image_map] ([it_guid],[vmt_guid],[internal_drive_mapping]) VALUES (@id_6469,@id_6469,'C')
end
go
