package org.ovirt.engine.core.common.queries;

import java.io.Serializable;

import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlElement;

@XmlType(namespace = "http://service.rhevm.redhat.com")
@XmlAccessorType(XmlAccessType.NONE)
public class ValueObjectPair implements Serializable {
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((key == null) ? 0 : key.hashCode());
        result = prime * result + ((value == null) ? 0 : value.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        ValueObjectPair other = (ValueObjectPair) obj;
        if (key == null) {
            if (other.key != null)
                return false;
        } else if (!key.equals(other.key))
            return false;
        if (value == null) {
            if (other.value != null)
                return false;
        } else if (!value.equals(other.value))
            return false;
        return true;
    }

    private static final long serialVersionUID = 5929476364021026257L;

    private Object key;
    private Object value;

    public ValueObjectPair() {
    }

    public ValueObjectPair(Object key, Object value) {
        this.key = key;
        this.value = value;
    }

    @XmlElement
    public Object getKey() {
        return key;
    }

    public void setKey(Object key) {
        this.key = key;
    }

    @XmlElement
    public Object getValue() {
        return value;
    }

    public void setValue(Object value) {
        this.value = value;
    }
}
