package org.ovirt.engine.core.rhevmencryptutils;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

import org.ovirt.engine.core.login.RhevmSecureIdentityLoginModule;

public class EncryptionUtilsTest {

    public void testEncryptDecrypt() {
        /*
         * try { String plain = "123456"; String keyFile = "/tmp/ca/.keystore"; String alias = "rhevm"; String encrypted
         * = EncryptionUtils.encrypt(plain, keyFile, "mypass", alias); String decrypted =
         * EncryptionUtils.decrypt(encrypted, keyFile, "mypass", alias); System.out.println("decrypted: " + decrypted);
         * assertEquals(plain, decrypted); } catch (Exception e) { fail(); }
         */
    }

    public void testMSCompat() {
        /*
         * String plain = "Hello World"; String cipher =
         * "cT7TWp5AGMJwz7420qCpZOnefuP7QxFrrmrNkn5uxaIY3ZWYHFZimCWx2dmiFdFSryFcOj1G/ZULTDiP8XfwJk2CWIk38B5I9JtmWUCUVNt7+y09BF4/b8Bg+XVXM1GzUFdxMggvicp16uRxiqGJhG8vqNHTTEt5Pv9q0/LVf4U="
         * ; String keyPath = "ca.pfx"; RefObject<String> error = new RefObject<String>(); String decrypted =
         * EncryptionUtils.Decrypt(cipher, keyPath, "mypass", error); System.out.println("decrypted: " + decrypted);
         * assertEquals(plain, decrypted);
         */
    }

    @Test
    public void testDefaultEndoceDecode() {
        String secret = "i'm going to be encrypted";
        String encode = EncryptionUtils.encode(secret, null, null);
        assertNotNull(encode);
        String decode = EncryptionUtils.decode(encode, null, null);
        assertNotNull(encode);
        assertTrue(secret.equals(decode));
    }

    @Test
    public void testRC2EndoceDecode() {
        String secret = "i'm going to be encrypted";
        String rc2Material = "123456";
        String rc2Algorithm = "RC2";
        String encode = EncryptionUtils.encode(secret, rc2Material, rc2Algorithm);
        assertNotNull(encode);
        String decode = EncryptionUtils.decode(encode, rc2Material, rc2Algorithm);
        assertNotNull(encode);
        assertTrue(secret.equals(decode));
    }

    @Test
    public void testMainEndoceDecode() throws Exception {
        String[] args = { "RHEVMadmin2009!"};
        RhevmSecureIdentityLoginModule.main(args);

        args = new String[] { "RHEVMadmin2009!", "jaas is the way", "Blowfish" };
        RhevmSecureIdentityLoginModule.main(args);


        args = new String[] { "RHEVMadmin2009!", "some passphrase", "Blowfish" };
        RhevmSecureIdentityLoginModule.main(args);

        args = new String[] { "RHEVMadmin2009!", "12345678$#", "RC2" };
        RhevmSecureIdentityLoginModule.main(args);
    }
}
